/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"time"
)

// checks if the SelfServiceResetRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SelfServiceResetRequest{}

// SelfServiceResetRequest struct for SelfServiceResetRequest
type SelfServiceResetRequest struct {
	AccountName NullableString `json:"accountName,omitempty"`
	DateOfBirth *time.Time     `json:"dateOfBirth,omitempty"`
	Captcha     *CaptchaAnswer `json:"captcha,omitempty"`
}

// NewSelfServiceResetRequest instantiates a new SelfServiceResetRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSelfServiceResetRequest() *SelfServiceResetRequest {
	this := SelfServiceResetRequest{}
	return &this
}

// NewSelfServiceResetRequestWithDefaults instantiates a new SelfServiceResetRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSelfServiceResetRequestWithDefaults() *SelfServiceResetRequest {
	this := SelfServiceResetRequest{}
	return &this
}

// GetAccountName returns the AccountName field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *SelfServiceResetRequest) GetAccountName() string {
	if o == nil || IsNil(o.AccountName.Get()) {
		var ret string
		return ret
	}
	return *o.AccountName.Get()
}

// GetAccountNameOk returns a tuple with the AccountName field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *SelfServiceResetRequest) GetAccountNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.AccountName.Get(), o.AccountName.IsSet()
}

// HasAccountName returns a boolean if a field has been set.
func (o *SelfServiceResetRequest) HasAccountName() bool {
	if o != nil && o.AccountName.IsSet() {
		return true
	}

	return false
}

// SetAccountName gets a reference to the given NullableString and assigns it to the AccountName field.
func (o *SelfServiceResetRequest) SetAccountName(v string) {
	o.AccountName.Set(&v)
}

// SetAccountNameNil sets the value for AccountName to be an explicit nil
func (o *SelfServiceResetRequest) SetAccountNameNil() {
	o.AccountName.Set(nil)
}

// UnsetAccountName ensures that no value is present for AccountName, not even an explicit nil
func (o *SelfServiceResetRequest) UnsetAccountName() {
	o.AccountName.Unset()
}

// GetDateOfBirth returns the DateOfBirth field value if set, zero value otherwise.
func (o *SelfServiceResetRequest) GetDateOfBirth() time.Time {
	if o == nil || IsNil(o.DateOfBirth) {
		var ret time.Time
		return ret
	}
	return *o.DateOfBirth
}

// GetDateOfBirthOk returns a tuple with the DateOfBirth field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SelfServiceResetRequest) GetDateOfBirthOk() (*time.Time, bool) {
	if o == nil || IsNil(o.DateOfBirth) {
		return nil, false
	}
	return o.DateOfBirth, true
}

// HasDateOfBirth returns a boolean if a field has been set.
func (o *SelfServiceResetRequest) HasDateOfBirth() bool {
	if o != nil && !IsNil(o.DateOfBirth) {
		return true
	}

	return false
}

// SetDateOfBirth gets a reference to the given time.Time and assigns it to the DateOfBirth field.
func (o *SelfServiceResetRequest) SetDateOfBirth(v time.Time) {
	o.DateOfBirth = &v
}

// GetCaptcha returns the Captcha field value if set, zero value otherwise.
func (o *SelfServiceResetRequest) GetCaptcha() CaptchaAnswer {
	if o == nil || IsNil(o.Captcha) {
		var ret CaptchaAnswer
		return ret
	}
	return *o.Captcha
}

// GetCaptchaOk returns a tuple with the Captcha field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SelfServiceResetRequest) GetCaptchaOk() (*CaptchaAnswer, bool) {
	if o == nil || IsNil(o.Captcha) {
		return nil, false
	}
	return o.Captcha, true
}

// HasCaptcha returns a boolean if a field has been set.
func (o *SelfServiceResetRequest) HasCaptcha() bool {
	if o != nil && !IsNil(o.Captcha) {
		return true
	}

	return false
}

// SetCaptcha gets a reference to the given CaptchaAnswer and assigns it to the Captcha field.
func (o *SelfServiceResetRequest) SetCaptcha(v CaptchaAnswer) {
	o.Captcha = &v
}

func (o SelfServiceResetRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SelfServiceResetRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.AccountName.IsSet() {
		toSerialize["accountName"] = o.AccountName.Get()
	}
	if !IsNil(o.DateOfBirth) {
		toSerialize["dateOfBirth"] = o.DateOfBirth
	}
	if !IsNil(o.Captcha) {
		toSerialize["captcha"] = o.Captcha
	}
	return toSerialize, nil
}

type NullableSelfServiceResetRequest struct {
	value *SelfServiceResetRequest
	isSet bool
}

func (v NullableSelfServiceResetRequest) Get() *SelfServiceResetRequest {
	return v.value
}

func (v *NullableSelfServiceResetRequest) Set(val *SelfServiceResetRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableSelfServiceResetRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableSelfServiceResetRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSelfServiceResetRequest(val *SelfServiceResetRequest) *NullableSelfServiceResetRequest {
	return &NullableSelfServiceResetRequest{value: val, isSet: true}
}

func (v NullableSelfServiceResetRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSelfServiceResetRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
